// Arkadia
#include "ark_core/ark_core.hpp"
// bin2header
#include "Version.hpp"

//
// Constants
//
//------------------------------------------------------------------------------
constexpr u32 READ_BLOCK_SIZE = 1024;


//------------------------------------------------------------------------------
ark_internal_function void
ShowHelp(ark::String const &help_string)
{
    ark::PrintLn("{}", help_string);
    ark::Exit(0);
}

//------------------------------------------------------------------------------
ark_internal_function void
ShowVersion()
{
    ark::PrintLn(
"{} - {} - stdmatt <stdmatt@pixelwizards.io>\n"
"Copyright (c) {} - stdmatt\n"
"This is a free software (GPLv3) - Share/Hack it\n"
"Check http://stdmatt.com for more :)\n",
    BuildInfo_bin2header.ProgramName,
    BuildInfo_bin2header.BuildSimpleVersionString  (),
    BuildInfo_bin2header.BuildSimpleCopyrightString()
);

    ark::Exit(0);
}

//
// Helper Functions
//
//------------------------------------------------------------------------------
ark_internal_function ark::String
MakeValidVariableName(ark::String const &filename)
{
    ark::String  var_name     = ark::PathUtils::Basename(filename);
    size_t const var_name_len = var_name.Length();
    for(size_t i = 0; i < var_name_len; ++i) {
        if(isalnum(var_name[i])) {
            var_name[i] = toupper(var_name[i]);
        } else {
            var_name[i] = '_';
        }
    }

    return var_name;
}

//------------------------------------------------------------------------------
ark_internal_function void
WriteInfoOfHeaderFile(FILE *output_file, ark::String const &input_filename, ark::String const &array_var_name)
{
    fprintf(output_file, "/*\nFile Header Generated by stdmatt's %s - %s\n",
        BuildInfo_bin2header.ProgramName,
        BuildInfo_bin2header.BuildSimpleVersionString().CStr()
    );
    fprintf(output_file, "Input Filename  : %s\n",     input_filename.CStr());
    fprintf(output_file, "Generation Date : %s\n*/\n", ark::DateTime::Now().ToDebugString().CStr());
}


//------------------------------------------------------------------------------
ark_internal_function void
WriteBeginOfHeaderFile(FILE *output_file, ark::String const &array_var_name)
{
    fprintf(output_file, "unsigned char %s[] = {\n", array_var_name.CStr());
}

//------------------------------------------------------------------------------
ark_internal_function void
WriteEndOfHeaderFile(FILE *output_file, ark::String const &array_var_name, u32 const array_length)
{
    fprintf(output_file, "}; // %s",            array_var_name.CStr());
    fprintf(output_file, "\n#define %s_LEN %u", array_var_name.CStr(), array_length);
}


//
// Entry Point
//
//------------------------------------------------------------------------------
i32
ark_main(ark::String const &command_line)
{
    namespace CMD = ark::CommandLine;
    CMD::Parser parser(command_line, CMD::Parser::ErrorHandling::DIE_ON_ERROR);

    auto const help_arg       = parser.CreateArgument("h", "help",       "Show this screen.");
    auto const version_arg    = parser.CreateArgument("v", "version",    "Show version and copyright info.");
    auto const outfile_arg    = parser.CreateArgument("o", "outfile",    "Write output to a file instead of stdout.", CMD::Argument::RequiresOneValue);
    auto const array_name_arg = parser.CreateArgument("",  "array-name", "Identifier for the array.",                 CMD::Argument::RequiresOneValue);

    //
    parser.Evaluate();
    if(help_arg->WasFound()) {
        ShowHelp(parser.GenerateHelpString());
    } else if(version_arg->WasFound()) {
        ShowVersion();
    }

    //
    ark::Array<ark::String> input_filenames = parser.GetPositionalValues();
    if(input_filenames.IsEmpty()) {
        ark::Fatal("Missing filenames - Aborting...");
        ark::Exit(1);
    } else if(input_filenames.Count() > 1) {
        ark::Warn("Multiple filenames were found - Ignoring all but the first one...");
    }

    //
    ark::String const input_fullname  = ark::PathUtils::Canonize(input_filenames.Front());
    if(!ark::PathUtils::IsFile(input_fullname)) {
        ark::Fatal("Invalid filename - Ignoring...\n   Filename: ({})", input_fullname);
    }

    ark::String const output_fullname = outfile_arg->HasValues()
        ? outfile_arg->GetFirstValue()
        : ark::PathUtils::ChangeExtension(input_fullname, ".h");

    //
    ark::File input_file(input_fullname,  "rb");
    if(input_file.Open().HasFailed()) {
        ark::Fatal("Failed to open file ({})", input_fullname);
    }

    ark::File output_file(output_fullname, "wb");
    if(outfile_arg->HasValues() && output_file.Open().HasFailed()) {
        ark::Fatal("Failed to open file ({})", output_fullname);
    }

    FILE *output_file_stream = outfile_arg->HasValues()
        ? output_file.GetInternalHandle()
        : stdout;

    //
    ark::String const array_var_name = MakeValidVariableName(
        array_name_arg->HasValues() ? array_name_arg->GetFirstValue() : input_fullname
    );
    WriteInfoOfHeaderFile (output_file_stream, input_fullname, array_var_name);
    WriteBeginOfHeaderFile(output_file_stream, array_var_name);

    u8 read_buffer [READ_BLOCK_SIZE] = {};
    u32 array_length = 0;
    while(true) {
        size_t const read_count = fread(read_buffer, sizeof(u8), READ_BLOCK_SIZE, input_file.GetInternalHandle());
        if(read_count == 0) {
            break;
        }
        for(size_t i = 0; i < read_count; ++i) {
            if(i != 0 && i % 10 == 0) {
                fprintf(output_file_stream, "%s", ark::NEW_LINE_STR);
            }
            fprintf(output_file_stream, "0x%02x, ", read_buffer[i]);
            fflush(output_file_stream);
            ++array_length;
        }
        fprintf(output_file_stream, "%s", ark::NEW_LINE_STR);
    }
    WriteEndOfHeaderFile(output_file_stream, array_var_name, array_length);

    return 0;
}
